//+------------------------------------------------------------------+
//|                                      DIBS_TriggerLines_v1.2a.mq4 |
//|                                  Copyright  2008, ForexArea.com |
//|                                         http://www.forexarea.com |
//|                                  		  Modified by AAD...       |
//|                                         Modified by LuboLabo     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, ForexArea.com"
#property link      "http://www.forexarea.com"

// For more DIBS information go to http://www.forexfactory.com/showthread.php?t=86766 
// or http://www.forexfactory.com/showthread.php?t=56907

/*
Updated: 8/11/2008 - I added full customizable options (color, size, width, and style) to 
this indicator. It now also has the option to be used on any time frame when the "Show DIBS 
On All Time Frames" option is set to True. DIBS open hours are now more specifically 
specified...
---



*/ 

#property indicator_chart_window

extern string  sComment0		= "(( Mods By LuboLabo ))";
extern string  sComment17		= "> Total hours to monitor (9-10).";
extern int     iBarsToTrade		= 10;
extern string  sComment18		= "--- Length/Width/Size Options ---";
extern string  sComment19		= "> Length of trigger lines (2-20).";
extern int     iTriggerLineLength	= 2;
extern string  sComment20		= "> Width of trigger lines (1-5).";
extern int     iTriggerLineWidth	= 1;
extern string  sComment24		= "--- Line Style Options ---";
extern string  sComment25		= "> 0=Solid, 1=Dash, 2=Dot";
extern string  sComment26		= "> 3=DashDot, 4=DashDotDot";
extern string  sComment27		= "> Styles 1-4 only work if you set the";
extern string  sComment28		= "> line width to 1.";
extern int     iTriggerLineStyle	= 2;
extern string  sComment29		= "--- Line Color Options ---";
extern color   cBuyTriggerLineClr	= DodgerBlue;
extern color   cSellTriggerLineClr	= DarkOrange;
extern string  sComment30		= "--- Display Options ---";
extern bool    bShowStoploss		= false;
extern string  sComment23		= "> Price label size(0-15).";
extern int     iPriceLabelSize	= 1;
extern string  sComment31		= "--- Alert Options ---";
extern string  sComment32		= "> Only set 1 alert option to True.";
extern string  sComment33		= "> Do not set both alerts to True!";
extern bool    bPopUpAlert		= false;
extern bool    bSoundAlert		= true;
extern string  sComment34		= "> Alert sound file name.";
extern string  sSoundFile		= "Alert2.wav";
extern string  sComment35		= "> Minute delay between alerts.";
extern int     iDelayBetweenAlarm	= 60;
extern string  sComment36		= "--- BackTesting Options ---";
extern string  sComment37		= "> BackTest False = Only shows todays DIBS.";
extern bool    bBackTest		= true;
extern string  sComment38		= "> Amount of bars to backtest for DIBS (200-50000).";
extern int     iBarsToCount		= 4;
extern string  sComment39		= "--- Show DIBS On All Time Frames ---";
extern bool    bDIBSOnAllCharts	= true;


double dBuyTriggerLines[], dSellTriggerLines[];
bool bDrawAll;
bool bDrawLines;
int iTriggerObjects = 10000;
int     iOpenHour		= 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   //NewBar();  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   DeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void DeleteAll(){  

   for(int j = 0; j <= 10000; j++){
      ObjectDelete("DIBS_Trigger_B" + j);
      ObjectDelete("DIBS_Trigger_S" + j);
      ObjectDelete("DIBS_DayOpen" + j);
      ObjectDelete("DIBS_DayClose" + j);
      ObjectDelete("DIBS_Stoploss_B" + j);
      ObjectDelete("DIBS_Stoploss_S" + j);
   } 
}

int start()
  {
  
     if(Period() != PERIOD_M30 && bDIBSOnAllCharts == false){Comment("DIBS is currently set to only work on the M30 time frame, set 'bDIBSOnAllCharts' option to True to display. Mods By L.Labo..."); return(0);}
  
     if(NewBar()){DeleteAll(); bDrawLines = true; iTriggerObjects = 10000;}

     int limit;
     int counted_bars=IndicatorCounted();
     int iBarHour;
     int iExtension;
     double dDayOpenPrice;
     bool bDrawToday;
     int iUniqueID;
     int i;

     
  //---- check for possible errors
     if(counted_bars<0) return(-1);

     if(iBarsToCount == 0){
         limit=Bars;
      }else{
         limit=iBarsToCount;
      }
      
      
  //---- main loop
  
while(bDrawLines==true){


   // MUST be left at -1
   for(i=limit; i>-1; i--){
      
      bDrawToday = false;
	   // only draw objects for today
      if(bBackTest == false && TimeDay(Time[i]) == TimeDay(TimeCurrent()) && TimeMonth(Time[i]) == TimeMonth(TimeCurrent())){
            bDrawToday = true;
         }else{
           bDrawToday = false;
         }
	     
     if(bBackTest == true){
            bDrawToday = true;
        }
        
			   
			   // see if we have an inside bar 
			   if(iHigh(NULL, 0, i) < iHigh(NULL, 0, i+1) && iLow(NULL, 0,i) > iLow(NULL, 0, i+1)){
			     
			      {
                  // draw buy trigger object 
                  iTriggerObjects--;
                  if(i<iBarsToTrade){
                        iExtension = i;
                        iUniqueID = iTriggerObjects;
                    }else{
                        iExtension = iTriggerLineLength-1;
                        iUniqueID = iTriggerObjects;
                     }
                  if(bSoundAlert && i == 1)Alerts(1);
                  if(bPopUpAlert && i == 1)Alert("DIBS " + Symbol() + " - Buy Trigger");
                     if(ObjectFind("DIBS_Trigger_B" + iUniqueID) != 0){
                           ObjectCreate("DIBS_Trigger_B" + iUniqueID, OBJ_TREND, 0, Time[i], iHigh(NULL, 0, i) , Time[i-iExtension], iHigh(NULL, 0, i));
                           ObjectSet("DIBS_Trigger_B" + iUniqueID, OBJPROP_RAY, false);
			         ObjectSet("DIBS_Trigger_B" + iUniqueID, OBJPROP_STYLE, iTriggerLineStyle);
                           ObjectSet("DIBS_Trigger_B" + iUniqueID, OBJPROP_WIDTH, iTriggerLineWidth);
                           ObjectSet("DIBS_Trigger_B" + iUniqueID, OBJPROP_COLOR, cBuyTriggerLineClr);
                        }else{
                           ObjectMove("DIBS_Trigger_B" + iUniqueID, 2, Time[i], iHigh(NULL, 0, i));  
                        }

                     if(bShowStoploss){
                        ObjectCreate("DIBS_Stoploss_B" + iUniqueID, OBJ_ARROW, 0, Time[i], iLow(NULL, 0, i));
                        ObjectSet("DIBS_Stoploss_B" + iUniqueID, OBJPROP_ARROWCODE, 5);
                        ObjectSet("DIBS_Stoploss_B" + iUniqueID, OBJPROP_COLOR, cBuyTriggerLineClr);
                        ObjectSet("DIBS_Stoploss_B" + iUniqueID, OBJPROP_WIDTH, iPriceLabelSize);
                    }
                    
               }
              
               {
                  // draw sell trigger object 
                  iTriggerObjects--;
                  if(i<iBarsToTrade){
                        iExtension = i;
                        iUniqueID = iTriggerObjects;
                    }else{
                        iExtension = iTriggerLineLength-1;
                        iUniqueID = iTriggerObjects;
                     }
                  if(bSoundAlert && i == 1)Alerts(1);
                  if(bPopUpAlert && i == 1)Alert("DIBS " + Symbol() + " - Sell Trigger");
                  if(ObjectFind("DIBS_Trigger_S" + iUniqueID) != 0){
                        ObjectCreate("DIBS_Trigger_S" + iUniqueID, OBJ_TREND, 0, Time[i], iLow(NULL, 0, i) , Time[i-iExtension], iLow(NULL, 0, i));
                        ObjectSet("DIBS_Trigger_S" + iUniqueID, OBJPROP_RAY, false);
			      ObjectSet("DIBS_Trigger_S" + iUniqueID, OBJPROP_STYLE, iTriggerLineStyle);
                        ObjectSet("DIBS_Trigger_S" + iUniqueID, OBJPROP_WIDTH, iTriggerLineWidth);
                        ObjectSet("DIBS_Trigger_S" + iUniqueID, OBJPROP_COLOR, cSellTriggerLineClr);
                     }else{
                        ObjectMove("DIBS_Trigger_S" + iUniqueID, 2, Time[i], iLow(NULL, 0, i)); 
                     }
                  if(bShowStoploss){
                     ObjectCreate("DIBS_Stoploss_S" + iUniqueID, OBJ_ARROW, 0, Time[i], iHigh(NULL, 0, i));
                     ObjectSet("DIBS_Stoploss_S" + iUniqueID, OBJPROP_ARROWCODE, 5);
                     ObjectSet("DIBS_Stoploss_S" + iUniqueID, OBJPROP_WIDTH, iPriceLabelSize);
                     ObjectSet("DIBS_Stoploss_S" + iUniqueID, OBJPROP_COLOR, cSellTriggerLineClr);
                 }
               
		         
			   
		    }// if 2
	   }// if 1    
   }// for
  bDrawLines = false;
}
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


bool NewBar() {

	static datetime LastTime = 0;
   
	if (Time[0] != LastTime) {
		LastTime = Time[0];
		bDrawLines = true;		
		return (true);
	} else
		return (false);
}

void Alerts(int Direction)
{
   static datetime AlertLastTime = 0;

   if(TimeCurrent() > AlertLastTime ) {
      AlertLastTime = TimeCurrent()+iDelayBetweenAlarm;
      PlaySound(sSoundFile);
   
   }
}

