//+------------------------------------------------------------------+
//|   TRO_PRICE_METER                                                |
//|                                                                  |
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

string myHHMM       = "14:00" ; // 05:00 am pst = 14:00 server time 


int ChartPeriod ;
int    digits, digits2;

color LineColor ;
 
double  point , DailyOpen;
 
string symbol, tChartPeriod  ;  

int      cd ;

int lastHH = 99 ;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   ChartPeriod = Period();
   

   tChartPeriod =  TimeFrameToString(ChartPeriod) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits2 = 0 ; point = point * 10 ; } else { digits2 = 0 ; }

 
       
    ObjectCreate("OtoC",OBJ_TREND,0,0,0,0,0);
    ObjectSet("OtoC",OBJPROP_COLOR,Yellow); 
    ObjectSet("OtoC",OBJPROP_RAY,false);    
    ObjectSet("OtoC",OBJPROP_WIDTH,2); 
          
   deinit() ;
   
   return(0);
  }



//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
//+------------------------------------------------------------------+
int deinit()
  {
    
   ObDeleteObjectsByPrefix("OtoC");   
       
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

if( ChartPeriod >= PERIOD_D1 ) { Comment ("***error - must be less than PERIOD_D1" ) ; return (-1) ; } 

   double  OP,CL,HI,LO;
   int rt1, i;
   
   if(lastHH != TimeHour(Time[0]) )
   {
      lastHH = TimeHour(Time[0]);
      myHHMM = lastHH + ":00" ;
   
   }
   
   DoDailyOpen(symbol) ;
    
   int shift=cd;   
   

    OP = iOpen(NULL,ChartPeriod ,shift) ; 
    CL = iClose(NULL,ChartPeriod ,0) ; 
    HI = iHigh(NULL,ChartPeriod ,0) ; 
    LO = iLow(NULL,ChartPeriod ,0) ; 


   if(CL > OP) { LineColor = Lime ; }
   else { if(CL < OP) { LineColor = Red ; } else { LineColor = Yellow ; } }

    ObjectCreate("OtoC",OBJ_TREND,0,0,0,0,0);
    ObjectSet("OtoC",OBJPROP_COLOR,LineColor); 
    ObjectSet("OtoC",OBJPROP_RAY,false);    
    ObjectSet("OtoC",OBJPROP_WIDTH,2); 
    
   ObjectMove("OtoC",0,Time[shift],OP);
   ObjectMove("OtoC",1,Time[0],CL);
      
           
return(0);
}
 
  
//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+ 

 

void DoDailyOpen(string doSymbol) 
{

int   yy = TimeYear(Time[0]);
int   mm = TimeMonth(Time[0]);
int   dd = TimeDay(Time[0]);  
   
string yymmddms = yy+"."+mm+"."+dd+" " + myHHMM ;
         
datetime var1 = StrToTime(yymmddms);  
   
datetime day=24*60*60;
datetime r= var1 ;

 

         cd=iBarShift(NULL,0,r,FALSE);
datetime r2=r-day;


if(TimeDayOfWeek(r2)==0) r2=r2-day-day;
int cd2=iBarShift(NULL,0,r2,FALSE);

if( var1 > Time[0] ) { r = r2 ;cd = cd2 ;} // if date/time is greater than current date/time go back 1 day

DailyOpen = iOpen(doSymbol,0,cd);    


}


//+------------------------------------------------------------------+ 
/* 
        
Comment(
 
"cd " , cd , "\n" , 
"pair " , symbol , "\n" , 
"DailyOpen " , DoubleToStr(DailyOpen,Digits) , "\n" ,
 
"") ; 
  
  
      

*/



