#property copyright "Kalenzo"
#property link      "http://www.fxservice.eu,  bartlomiej.gorski@gmail.com"

#property indicator_separate_window

#property indicator_buffers 2

extern 	int TimeFrame = 15,//in minutes
			iPeriod = 100;
extern 	color 	OneColor = Blue,
				UpColor = Green,
				DnColor = Red;
extern 	bool UseOneColor = true;
double sizerH[],sizerL[];


int init()
{
	SetIndexBuffer(0,sizerH);
	SetIndexStyle(0,DRAW_NONE,EMPTY,0);
	SetIndexBuffer(1,sizerL);
	SetIndexStyle(1,DRAW_NONE,EMPTY,0);
	
	IndicatorShortName("Custom Timeframe M("+TimeFrame+")"); 
	return(0);
}
	
int start()
{	
	double h = iHigh(Symbol(),1, Highest(NULL,1,MODE_HIGH,iPeriod*TimeFrame));  
	double l = iLow(Symbol(),1, Lowest(NULL,1,MODE_LOW,iPeriod*TimeFrame));
	
		ArrayInitialize(sizerH,h);	
		ArrayInitialize(sizerL,l);	
	
	for(int i=iPeriod;i>=0;i--)
	{
		
		double O = iOpen(Symbol(),TimeFrame,i); 
		double H = iHigh(Symbol(),TimeFrame,i); 
		double L = iLow(Symbol(),TimeFrame,i);
		double C = iClose(Symbol(),TimeFrame,i); 
		
		if(UseOneColor)
		{
			drawLine(TimeFrame+"BB"+i,Time[i],O,C,3,OneColor);
			drawLine(TimeFrame+"SB"+i,Time[i],H,L,1,OneColor);
		}
		else
		{	
			if(C<O)
			{
				drawLine(TimeFrame+"BB"+i,Time[i],O,C,3,DnColor);
				drawLine(TimeFrame+"SB"+i,Time[i],H,L,1,DnColor);
			}
			else
			{
				drawLine(TimeFrame+"BB"+i,Time[i],O,C,3,UpColor);
				drawLine(TimeFrame+"SB"+i,Time[i],H,L,1,UpColor);
			}			
		}			
	}
	
	
	
	return(0);
}

void drawLine(string name,datetime time, double pfrom, double pto, int width,color Col)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, WindowFind("Custom Timeframe M("+TimeFrame+")"), time, pfrom,time,pto);
            
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,0);
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, WindowFind("Custom Timeframe M("+TimeFrame+")"), time, pfrom,time,pto);
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
            ObjectSet(name,OBJPROP_RAY,0);
          
         }
}

